; Channel Links add-on by David "Saturn" van Moolenbroek <saturn@quakenet.org>
; Use/modify however you want, but please keep my name in it. Thank you!

alias -l dlldir return $scriptdir
alias -l confdir return $scriptdir

alias -l spopupdll return $qt($dlldir $+ spopup.dll)
alias -l datafile return $qt($confdir $+ chanlinks.dat)

menu menubar,status {
  -
  Channel Links...:chanlinks
}

alias chanlinks dialog -m chanlinks chanlinks

dialog -l chanlinks {
  title "Channel Links"
  size -1 -1 220 250
  option pixels

  text "Double-click command:", 1, 15 8 120 18
  edit "", 2, 10 26 200 20
  text "Right-click popup:", 3, 15 52 120 20
  edit "", 4, 10 70 200 140, multi return autohs autovs
  button "&OK", 5, 38 219 70 23, ok
  button "&Cancel", 6, 112 219 70 23, cancel
}

on *:DIALOG:chanlinks:init:0:{
  var %i = 1
  while ($hget(chanlinks,%i) != $null) {
    did -i $dname 4 %i $v1
    inc %i
  }
  did -ra $dname 2 $hget(chanlinks,dclick)
}
on *:DIALOG:chanlinks:sclick:5:{
  var %i = 1, %k = 1, %n = $did(4).lines
  hdel -w chanlinks *
  while (%i <= %n) {
    if ($did(4,%i) != $null) {
      var %t = $v1
      if ($count(%t,$chr(123)) != $count(%t,$chr(125))) {
        if ($input(Multi-line popup entries are not allowed! $+ $crlf $+ $&
          $crlf $+ Continue anyway?,uvwy,Unbalanced brackets) == $no) halt
      }
      elseif ($gettok(%t,-1,32) == $!&) {
        if ($input(Multi-line popup entries are not allowed! $+ $crlf $+ $&
          $crlf $+ Continue anyway?,uvwy,Continuation found) == $no) halt
      }
      hadd chanlinks %k %t
      inc %k
    }
    inc %i
  }
  if ($did(2) != $null) hadd chanlinks dclick $v1
  hsave chanlinks $datafile
}

on *:START:{
  hmake chanlinks 16
  if ($isfile($datafile)) hload chanlinks $datafile
  else {
    hadd chanlinks 1 Join Channel:/join $!1
    hadd chanlinks 2 List Users:/names $!1
    hadd chanlinks 3 Show Topic:/topic $!1
    hadd chanlinks dclick /join $!1
  }
}
on *:UNLOAD:hfree chanlinks

alias -l spopup {
  var %i = 1, %h = $1, %p = $2-
  tokenize 32 %p
  dll $spopupdll clear

  while ($hget(%h,%i) != $null) {
    if ($regex($v1,/^(\.*)([^:]+)(:)?/)) {
      var %d = $iif($regml(3) || $regml(2) == -,0,16) $($regml(2),2)
      if ($regex(style,$gettok(%d,2,32),/^\$style\((\d+)\)$/i)) $&
        %d = $or(%d,$and($regml(style,1),15))) $gettok(%d,3-,32)
      dll $spopupdll add %i $len($regml(1)) %d
    }
    inc %i
  }

  var %r = $dll($spopupdll,popup,$mouse.dx $mouse.dy)
  if ($regex($hget(%h,%r),/:(.+)/)) $&
    scid $cid tokenize 32 $(%p |,0) $regml(1)
}

alias -l getchan {
  var %c = $regsubex($strip($1),/^[\Q $+ $prefix $+ \E]+/,)
  return $iif($left(%c,1) isin $chantypes,%c)
}
alias -l cleanup {
  var %c = $gettok($1,1,44)
  if ($right(%c,1) isin .:;) %c = $left(%c,-1)
  elseif ($right(%c,1) isin "') {
    var %t = $deltok($hotline,$gettok($hotlinepos,1,32) $+ -,32)
    if (2 \\ $count(%t,$right(%c,1))) %c = $left(%c,-1)
  }
  elseif ($pos(>}] $+ $chr(41),$right(%c,1))) {
    var %t = $deltok($hotline,$gettok($hotlinepos,1,32) $+ -,32)
    var %l = $mid(<{[ $+ $chr(40),$v1,1), %r = $right(%c,1)
    var %d = $iif($calc($count(%t,%l) - $count(%t,%r)) >= 0,$v1,1)
    if (%d > 0) var %c = $regsubex(%c,$+(/\Q,%r,\E{1,$chr(44),%d,}$/),)
  }
  return %c
}
on ^*:HOTLINK:*:*:{
  if ($getchan($1) == $null) halt
  var %c = $v1

  if ($mouse.key & 16) set -eu60 %cl.coords $mouse.x $mouse.y
  elseif (%cl.coords == $mouse.x $mouse.y) spopup chanlinks $cleanup(%c)
  else unset %cl.coords
}
on *:HOTLINK:*:*:{
  var %c = $cleanup($$getchan($1))

  if ($hget(chanlinks,dclick) != $null) $&
    scid $cid tokenize 32 $(%c |,0) $v1
}
